
From iaint@CU-SeeMe.educ.utas.edu.au Mon Jul 21 10:22:53 1997
Date: Sun, 6 Jul 1997 22:03:14 +1000 (EST)
From: Iain Templeton <iaint@CU-SeeMe.educ.utas.edu.au>
Reply-To: aros-dev@wi-pc44.fh-konstanz.de
To: Oldin' McGroin <aros-dev@wi-pc44.fh-konstanz.de>
Subject: [aros-dev] Re: Set/Setenv/Alias

On 6 Jul 1997, Lennard voor den Dag wrote:

> >> And you don't need to use list if you don't want to, I have code using
> >> ExAll() thats not very long.
> > I thought ExAll() just examined a whole directory?
> 
> Yes, the same as c:list does, only now you don't have to rely on an
> external command. This all applies only to setenv though: ExAll() "ENV:".
> 

This should do something like what you want. Could be better ways, but it
saves having to load an external program into memory, plus as it is built
into the shell under 2.04, you don't want to do that in my opinion
anyway.

    struct ExAllControl *eac;
    struct ExAllData *ead, *eaData;
    BPTR lock;
    BOOL more;

    lock = Lock("ENV:", ACCESS_READ);
    if(lock)
    {
	eac = AllocDosObject(DOS_EXALLCONTROL,NULL);
	if(eac)
	{
	    eaData = AllocMem(4096, MEMF_ANY|MEMF_CLEAR);
	    if(eaData)
	    {
		eac->eac_LastKey = 0;

		do
		{
		    more = ExAll(lock, eaData, 4096, ED_TYPE, eac);
		    if((!more)  && (IoErr() != ERROR_NO_MORE_ENTRIES))
		    {
			/* Failed abnormally */
			break;
		    }
		    if(eac->eac_Entries == 0)
		    {
			/* Failed normally */
			continue;
		    }
		    ead = (struct ExAllData *)eaData;
		    do
		    {
			if(ead->ed_Type < 0)
			{
			    FPuts(Output(), ead->ed_Name);
			    FPutC(Output(), '\n');
			}
			ead = ead->ed_Next;
		    } while(ead);

		} while(more);
		FreeMem(ead, 4096);

	    } /* If (allocmem for ead) */
	    FreeDosObject(DOS_EXALLCONTROL, eac);

	} /* If(allocated mem for eac) */
	UnLock(lock);

    } /* If locked file */

------------------------------------------------------------------------------
         AROSDML - Amiga Replacement OS Developer Mailing List
