/*
    (C) 1995-96 AROS - The Amiga Replacement OS
    $Id: freedosobject.c,v 1.7 1997/03/26 19:21:35 digulla Exp $

    Desc:
    Lang: english
*/
#include <exec/memory.h>
#include <proto/exec.h>
#include <dos/exall.h>
#include <dos/rdargs.h>
#include "dos_intern.h"

/*****************************************************************************

    NAME */
#include <proto/dos.h>

	AROS_LH2(void, FreeDosObject,

/*  SYNOPSIS */
	AROS_LHA(ULONG, type, D1),
	AROS_LHA(APTR,  ptr,  D2),

/*  LOCATION */
	struct DosLibrary *, DOSBase, 39, Dos)

/*  FUNCTION
	Frees an object allocated with AllocDosObject.

    INPUTS
	type - object type. The same parameter as given to AllocDosObject().
	ptr  - Pointer to object.

    RESULT

    NOTES

    EXAMPLE

    BUGS

    SEE ALSO

    INTERNALS

    HISTORY
	29-10-95    digulla automatically created from
			    dos_lib.fd and clib/dos_protos.h

*****************************************************************************/
{
    AROS_LIBFUNC_INIT
    AROS_LIBBASE_EXT_DECL(struct DosLibrary *,DOSBase)

    switch(type)
    {
	case DOS_FILEHANDLE:
	{
	    struct FileHandle *fh=(struct FileHandle *)ptr;
	    if(fh->fh_Flags&FHF_BUF)
		FreeMem(fh->fh_Buf,fh->fh_Size);
	    FreeMem(fh,sizeof(struct FileHandle));
	    break;
	}
	case DOS_FIB:
	    FreeMem(ptr,sizeof(struct FileInfoBlock));
	    break;
	case DOS_EXALLCONTROL:
	    FreeMem(ptr,sizeof(struct ExAllControl));
	    break;
	case DOS_CLI:
	{
	    struct CommandLineInterface *cli=(struct CommandLineInterface *)ptr;
	    BPTR *cur, *next;
	    cur=(BPTR *)BADDR(cli->cli_CommandDir);
	    FreeMem(ptr,sizeof(struct CommandLineInterface));
	    while(cur!=NULL)
	    {
		next=(BPTR *)BADDR(cur[0]);
		UnLock(cur[1]);
		FreeVec(cur);
		cur=next;
	    }
	    break;
	case DOS_RDARGS:
	    FreeArgs (ptr);
	    break;
	}
    }
    AROS_LIBFUNC_EXIT
} /* FreeDosObject */
