/*
    (C) 1995-96 AROS - The Amiga Replacement OS
    $Id: deleteiorequest.c,v 1.8 1997/05/12 10:32:13 aros Exp $

    Desc: Free an I/O request.
    Lang: english
*/
#include "exec_intern.h"
#include <aros/libcall.h>
#include <exec/io.h>
#include <proto/exec.h>

/*****************************************************************************

    NAME */

	AROS_LH1(void, DeleteIORequest,

/*  SYNOPSIS */
	AROS_LHA(struct IORequest *, iorequest, A0),

/*  LOCATION */
	struct ExecBase *, SysBase, 110, Exec)

/*  FUNCTION
	Delete an I/O request created with CreateIORequest().

    INPUTS
	iorequest - Pointer to I/O request structure or NULL.

    RESULT

    NOTES

    EXAMPLE

    BUGS

    SEE ALSO

    INTERNALS

    HISTORY

******************************************************************************/
{
    AROS_LIBFUNC_INIT

    if(iorequest!=NULL)
	/* Just free the memory */
	FreeMem(iorequest,iorequest->io_Message.mn_Length);
    AROS_LIBFUNC_EXIT
}

