/*
    Copyright (C) 1995-97 AROS - The Amiga Replacement OS
    $Id: exec_intern.h,v 1.6 1997/08/05 13:27:13 iaint Exp $

    Desc: Private data belonging to exec.library
    Lang:
*/
#ifndef __EXEC_INTERN_H__
#define __EXEC_INTERN_H__

/* This is a short file that contains a few things every Exec function
    needs */

#ifndef AROS_SYSTEM_H
#   include <aros/system.h>
#endif
#ifndef AROS_OPTIONS_H
#   include <aros/options.h>
#endif
#ifndef AROS_LIBCALL_H
#   include <aros/libcall.h>
#endif
#ifndef EXEC_EXECBASE_H
#   include <exec/execbase.h>
#endif
#ifndef PROTO_EXEC_H
#   include <proto/exec.h>
#endif

#if UseLVOs
extern void __AROS_InitExecBase (void);
#endif

void aros_print_not_implemented (char * name);

/* These are the bit definitions of the SysFlags and AttnResched flags.
    They are listed here more as somewhere to list them.
*/

#define SFB_SoftInt         5   /* There is a software interrupt */
#define SFF_SoftInt         (1L<<5)

#define ARB_AttnSwitch      7   /* Delayed Switch() pending */
#define ARF_AttnSwitch      (1L<<7)
#define ARB_AttnDispatch   15   /* Delayed Dispatch() pending */
#define ARF_AttnDispatch    (1L<<15)

#endif /* __EXEC_INTERN_H__ */
