/*
    (C) 1995-96 AROS - The Amiga Replacement OS
    $Id: askfont.c,v 1.1 1997/03/06 15:59:24 digulla Exp $

    Desc:
    Lang: english
*/
#include "graphics_intern.h"

/*****************************************************************************

    NAME */
#include <graphics/text.h>
#include <proto/graphics.h>

	AROS_LH2(void, AskFont,

/*  SYNOPSIS */
	AROS_LHA(struct RastPort *, rp, A1),
	AROS_LHA(struct TextAttr *, textAttr, A0),

/*  LOCATION */
	struct GfxBase *, GfxBase, 79, Graphics)

/*  FUNCTION
	Query the attributes of the current font in a RastPort.

    INPUTS
	rp - Query this RastPort.

    RESULT
	textAttr will contain a description of the font.

    NOTES

    EXAMPLE

    BUGS

    SEE ALSO

    INTERNALS

    HISTORY

*****************************************************************************/
{
    AROS_LIBFUNC_INIT
    AROS_LIBBASE_EXT_DECL(struct GfxBase *,GfxBase)

    textAttr->ta_Name  = rp->Font->tf_Message.mn_Node.ln_Name;
    textAttr->ta_YSize = rp->Font->tf_YSize;
    textAttr->ta_Style = rp->Font->tf_Style;
    textAttr->ta_Flags = rp->Font->tf_Flags;

    AROS_LIBFUNC_EXIT
} /* AskFont */
