/*
    (C) 1997 AROS - The Amiga Replacement OS
    $Id: initlayers.c,v 1.1 1997/07/08 20:16:43 ldp Exp $

    Desc:
    Lang: english
*/
#include <aros/libcall.h>
#include <proto/exec.h>
#include <proto/alib.h>

#define DEBUG 0
#include <aros/debug.h>
#undef kprintf

/*****************************************************************************

    NAME */
#include <proto/layers.h>
#include "layers_intern.h"

	AROS_LH1(void, InitLayers,

/*  SYNOPSIS */
	AROS_LHA(struct Layer_Info *, li, A0),

/*  LOCATION */
	struct LayersBase *, LayersBase, 5, Layers)

/*  FUNCTION
	Initializes the supplied Layer_Info, so it's ready for use.
	Leaves the Layer_Info in an unlocked state.

    INPUTS
	li -- pointer to Layer_Info structure

    RESULT

    NOTES
	This function is obsolete. Use NewLayerInfo() instead.

    EXAMPLE

    BUGS

    SEE ALSO
	NewLayerInfo

    INTERNALS

    HISTORY
	27-11-96    digulla automatically created from
			    layers_lib.fd and clib/layers_protos.h

*****************************************************************************/
{
    AROS_LIBFUNC_INIT
    AROS_LIBBASE_EXT_DECL(struct LayersBase *,LayersBase)

    UWORD i;

    D(bug("InitLayers(li @ $%lx)\n", li));

    for(i = 0; i < sizeof(*li); i++)
	((UBYTE *)li)[i] = 0;

    NewList((struct List *)&li->gs_Head);

    InitSemaphore(&li->Lock);

    li->fatten_count = -1;

    AROS_LIBFUNC_EXIT
} /* InitLayers */
